﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

// yabu
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace client
{
    public partial class Form1 : Form
    {
        TcpClient client;
        NetworkStream stream;
        bool connect = false;
        Thread thread;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string fqdn;
            int port_no;
            string ipAddress;

            string input = textBox3.Text;
            if (int.TryParse(input, out int result))
            {
            }
            else
            {
                textBox4.AppendText("port no の数値が不正です\r\n");
                return;
            }
            port_no = result;

            fqdn = textBox1.Text;
            try
            {
                // FQDNをIPアドレスに変換
                // localhost のとき
                // ipv6 の ::1 が返ってくる。127.0.0.1 に直す

                IPAddress[] addresses = Dns.GetHostAddresses(fqdn);
                if (addresses.Length > 0)
                {
                    // 最初のIPアドレスを取得
                    ipAddress = addresses[0].ToString();
                    if (ipAddress == "::1") {
                        ipAddress = "127.0.0.1";
                    }    
                    textBox4.AppendText($"address: {ipAddress}\r\n");
                    textBox2.Text = ipAddress;
                }
                else
                {
                    textBox4.AppendText("IP address not found.\r\n");
                    return;
                }
            }
            catch (Exception ex)
            {
//              $ は { } を使った文字列を許可する
                textBox4.Text = $"Error: {ex.Message}\r\n";
                return;
            }
            try
            {
                client = new TcpClient(fqdn, port_no);
            }
            catch (SocketException ex)
            {
                textBox4.AppendText($"接続失敗 {ex.Message}\r\n");
                return;
            }
            textBox4.AppendText("接続成功\r\n");
            textBox5.Text = "";
            textBox5.Focus();
            textBox6.Text = "";
            connect = true;

            stream = client.GetStream();
            thread = new Thread(new ThreadStart(ReadThread));
            thread.Start();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if ( connect == true )
            {
                connect = false;
                NetworkStream stream = client.GetStream();
                stream.Close();
                client.Close();
                textBox4.AppendText("切断しました\r\n");
            }
            else
            {
                textBox4.AppendText("接続していません\r\n");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if ( connect == true)
            {
                stream.Close();
                client.Close();
            }
            Application.Exit();
        }

        private void textBox5_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string[] lines = textBox5.Text.Split(new[] 
                    { Environment.NewLine }, StringSplitOptions.None);
                string lastLine = lines[lines.Length - 1];
                textBox5.AppendText("\r\n");
                string lastLine2 = lastLine + "\r\n";

                if (connect == true)
                {
                    byte[] data = Encoding.UTF8.GetBytes(lastLine2);
                    stream.Write(data, 0, data.Length);
                    textBox4.AppendText($"send: |{lastLine}|\r\n");
                }
                e.SuppressKeyPress = true;
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                button1.Focus();
                e.SuppressKeyPress = true; // Enterキーのデフォルト動作を抑制
            }
        }

        private void WriteToMessageBox(string text)
        {
            if (textBox4.InvokeRequired)
            {
                textBox4.Invoke(new Action<string>(WriteToMessageBox), text);
            }
            else
            {
                textBox4.AppendText(text);
            }
        }

        private void WriteToRecvBox(string text)
        {
            if (textBox6.InvokeRequired)
            {
                textBox6.Invoke(new Action<string>(WriteToRecvBox), text);
            }
            else
            {
                textBox6.AppendText(text);
            }
        }

        private void ReadThread()
        {
            byte[] buffer = new byte[1024];
            int bytesRead;

            try
            {
                while (true)
                {
                    bytesRead = stream.Read(buffer, 0, buffer.Length);
                    if (bytesRead > 0)
                    {
                        string receivedData =
                            Encoding.UTF8.GetString(buffer, 0, bytesRead);
                        WriteToRecvBox(receivedData);
                    } 
                    else if (bytesRead == 0)
                    {
                        WriteToMessageBox("返り値０　切断されました\r\n");
                        stream.Close();
                        client.Close();
                        connect = false;
                        break;
                    }
                }
            }
            catch (Exception ex)
            {
                WriteToMessageBox("例外発生　切断されました\r\n");
//                WriteToMessageBox(ex.ToString());
                stream.Close();
                client.Close();
                connect = false;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (connect == true)
            {
                stream.Close();
                client.Close();
            }
        }
    }
}
